<template>
  <div class="registration">
    <h2 class="title">Create an account</h2>
    <social-auth></social-auth>
    <form class="registration__form" @submit.prevent="registration">

      <!-- name -->
      <v-input  name="Username"
                type="text"
                v-model="user.userName"
                @change="updateUserName"
                :isError="$v.user.userName.$error">
        <template slot="error">
          <div class="error" v-if="!$v.user.userName.required">Field is required</div>
          <div class="error" v-else-if="!$v.user.userName.checkUserName">{{$v.user.userName.$params.checkUserName}}</div>
        </template>
      </v-input>

      <!-- email -->
      <v-input  name="Email"
                type="email"
                v-model="user.email"
                @change="updateUserEmail"
                :isError="$v.user.email.$error">
        <template slot="error">
          <div class="error" v-if="!$v.user.email.required">
            Email is required
          </div>
          <div class="error" v-if="!$v.user.email.email">
            Incorrect Email format
          </div>
          <div class="error" v-else-if="!$v.user.email.checkEmail">
            {{$v.user.email.$params.checkEmail}}
          </div>
        </template>
      </v-input>

      <!-- pass -->
      <v-input  name="Password"
                :type="typePassword"
                v-model="user.password"
                @change="updateUserPassword"
                :isError="$v.user.password.$error">
        <template slot="optional">
          <button class="btn btn--empty" type="button" name="showPass" @click="showPass = !showPass">
            <img width="20" src="@/assets/img/svg/eye.svg" alt="eye" v-if="showPass">
            <img width="20" src="@/assets/img/svg/hide.svg" alt="eye" v-else>
          </button>
        </template>
        <template slot="error">
          <div class="error" v-if="!$v.user.password.required">Password is required</div>
          <div class="error" v-else-if="!$v.user.password.regExPass">Your password is too simple</div>
          <div class="error" v-else-if="!$v.user.password.minLength">Password must have at least {{$v.user.password.$params.minLength.min}} characters</div>
          <div class="error" v-else-if="!$v.user.password.maxLength">Password must have no more {{$v.user.password.$params.maxLength.max}} characters</div>
        </template>
      </v-input>

      <!-- password meter -->
      <password-meter :pass="user.password"></password-meter>

      <!--confirm pass -->
      <v-input  name="Confirm password"
                :type="typePassword"
                v-model="user.confirmPassword"
                @change="updateUserConfirmPassword"
                :isError="$v.user.confirmPassword.$error">
        <template slot="optional">
          <button class="btn btn--empty" type="button" name="showPass" @click="showPass = !showPass">
            <img width="20" src="@/assets/img/svg/eye.svg" alt="eye" v-if="showPass">
            <img width="20" src="@/assets/img/svg/hide.svg" alt="eye" v-else>
          </button>
        </template>
        <template slot="error">
          <div class="error" v-if="!$v.user.confirmPassword.sameAsPassword">Passwords must be identical.</div>
        </template>
      </v-input>

      <!-- currency -->
      <Dropdown class="dropdown--input"
                :options="currencies"
                :label="true"
                placeholder="Currency"
                v-model="user.currency"
                @change="updateCurrency"
                :isError="$v.user.currency.name.$error" v-slot>
        <div class="error" v-if="!$v.user.currency.name.currency">Currency is required</div>
      </Dropdown>

      <!-- T&C -->
      <div class="checkbox" :class="{'checkbox--error' : $v.user.acceptTC.$error}">
        <input class="checkbox__input" id="terms-of-use" type="checkbox" v-model="user.acceptTC">
        <label class="checkbox__label" for="terms-of-use">
          <span class="checkbox__text">
            I accept the <a class="link" href="#">Terms &amp; Conditions and Privacy policy</a>
          </span>
        </label>
        <div class="checkbox__error">
          <div class="error" v-if="!$v.user.acceptTC.checked">
            Terms &amp; Conditions and Privacy policy consent must be granted
          </div>
        </div>
      </div>

      <!-- btn -->
      <button class="btn btn--withBtn" type="submit" name="Create an account">
        Create an account
        <span class="btn-in-btn">
          <img src="@/assets/img/svg/triangle.svg" alt="Arrow">
        </span>
      </button>
    </form>
  </div>
</template>

<script>
import SocialAuth from '@/components/Authorization/SocialAuth';
import Input from '@/components/Input';
import Dropdown from '@/components/Dropdown';
import PasswordMeter from '@/components/Authorization/PasswordMeter';
import call from '@/services/callService';
import {mapMutations} from 'vuex';
import {helpers, required, sameAs, email, minLength, maxLength} from 'vuelidate/lib/validators';
const touchMap = new WeakMap();

// Get Password Policy
let regExPass = helpers.regex('alpha', /(?=.*\d+)(?=.*[A-Za-z]+).{8,20}/);
(async () => {
  let result = await call.getPasswordPolicy();
  if (result) {
    (regExPass === helpers.regex('alpha', new RegExp(result.regularExpression))) ? 0 : regExPass = helpers.regex('alpha', new RegExp(result.regularExpression))
  }
})();


export default {
  name: 'Reg',
  data() {
    return {
      user: {
        userName: '',
        email: '',
        password: '',
        confirmPassword: '',
        country: '',
        currency: {
          name: undefined
        },
        birthDate: "1970-12-30",
        acceptTC: true
      },
      showPass: false,
      currencies: [],
      activationUrl: 'http://localhost:8080/#/activation&key='
    }
  },
  validations: {
    user: {
      userName: {
        required,
        async checkUserName(value) {
          try {
            let result = await call.validateUsername(value);
            if (result.isAvailable) {
              return true;
            } else {
              this.$v.user.userName.$params.checkUserName = result.error;
              return false;
            }
          }
          catch(err) {
            const message = err.desc || JSON.stringify(err);
            throw new Error("EM Username Validations Error:" + message);
          }
        }
      },
      email: {
        required,
        email,
        async checkEmail(value) {
          try {
            let result = await call.validateEmail(value);
            if (result.isAvailable) {
              return true;
            } else {
              this.$v.user.email.$params.checkEmail = result.error;
              return false;
            }
          }
          catch(err) {
            this.$v.user.email.$params.checkEmail = err.desc || JSON.stringify(err);
            return false;
          }
        }
      },
      password: {
        required,
        minLength: minLength(8),
        maxLength: maxLength(20),
        regExPass
      },
      confirmPassword: {
        sameAsPassword: sameAs('password')
      },
      currency: {
        name: {
          required
        }
      },
      acceptTC: {
        checked: value => value === true
      }
    }
  },
  components:{
    'social-auth': SocialAuth,
    'v-input': Input,
    Dropdown,
    PasswordMeter
  },
  methods: {
    ...mapMutations(['UPDATE_AUTH_COMPONENT']),
    registration() {
      let disabled = false;
      this.$v.user.userName.$touch();
      this.$v.user.email.$touch();
      this.$v.user.password.$touch();
      this.$v.user.confirmPassword.$touch();
      this.$v.user.currency.$touch();
      this.$v.user.acceptTC.$touch();
      if (this.$v.user.userName.$error ||
          this.$v.user.email.$error ||
          this.$v.user.password.$error ||
          this.$v.user.confirmPassword.$error ||
          this.$v.user.currency.$error) {
        return 0;
      }
      let params = {
        "emailVerificationURL": this.activationUrl,
        "email": this.user.email,
        "password": this.user.password,
        "currency": this.user.currency.code,
        "username": this.user.email,
        "country": this.user.country,
        "birthDate": this.user.birthDate,
        "userConsents": {
            "termsandconditions": this.user.acceptTC,
            "emailmarketing": false,
            "sms": false,
             "3rdparty": false
        }
      };
      if (!disabled) {
        disabled = true;
        this.accountRegister(params)
          .then((response) => {
            this.$notify({
              group: 'app',
              type:'success',
              text: 'Registration completed successfully. Check your email to activate your account'
            });
            console.log("Регистрация прошла успешно...", response);
            this.UPDATE_AUTH_COMPONENT({name: 'log', isShown: true});
          })
          .catch((err) => {
            const message = err.desc || JSON.stringify(err);
            this.$notify({
              group: 'app',
              type:'error',
              text: message
            });
            console.error(`EM Registration Error: ${message}`);
          })
          .finally(() => {
            disabled = false;
          });
      }
    },
    async accountRegister(params) {
      return await call.accountRegister(params);
    },
    updateUserName(val) {
      this.delayTouch(this.$v.user.userName);
      this.user.userName = val;
    },
    updateUserEmail(val) {
      this.delayTouch(this.$v.user.email);
      this.user.email = val;
    },
    updateUserPassword(val) {
      this.delayTouch(this.$v.user.password);
      this.user.password = val;
    },
    updateUserConfirmPassword(val) {
      this.delayTouch(this.$v.user.confirmPassword);
      this.user.confirmPassword = val;
    },
    updateCurrency(val) {
      this.user.currency = val;
    },
    async getCurrencies() {
      try {
        let result = await call.getCurrencies();
        if (result) {
          this.currencies = result;
        }
      }
      catch(err) {
        this.$notify({
          group: 'app',
          type:'warn',
          text: err
        });
        console.error(`EM getCurrencies Error: ${err}`);
      }
    },
    async getCountries() {
      try {
        let result = await call.getCountries();
        if (result) {
          this.user.country = result.currentIPCountry;
        }
      }
      catch(err) {
        this.$notify({
          group: 'app',
          type:'warn',
          text: err
        });
        console.error(`EM getCountries Error: ${err}`);
      }
    },
    delayTouch($v) {
      $v.$reset();
      if (touchMap.has($v)) {
        clearTimeout(touchMap.get($v));
      }
      touchMap.set($v, setTimeout($v.$touch, 1000));
    }
  },
  computed: {
    typePassword() {
      return (this.showPass) ? 'text' : 'password';
    }
  },
  created() {
    this.getCurrencies();
    this.getCountries();
  }
}
</script>

<style lang="sass" scoped>
.title
  font-family: $mainFont
  font-size: rem(32)
  line-height: 1.2
  margin: rem(70) 0 rem(36)
  text-align: left
.registration
  &__form >
    margin-top: rem(50)
    .input
      margin-top: rem(36)
    .dropdown
      margin-top: rem(36)
    .checkbox
      margin-top: rem(36)
    .btn
      margin-top: rem(30)
    .password-meter
      margin-top: rem(26)
</style>
